//////////////////////////////////////////////////////////////////////////////
//
//  libtoolmat.cpp
//
//  Description:
//      Contains Unigraphics entry points for the application.
//
//////////////////////////////////////////////////////////////////////////////

/*  Include files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <conio.h>
#include <time.h>
#include <math.h>
//  Include files
#include <uf.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_defs.h>
/* These include files are needed for the following template code.            */
#include <uf_styler.h>
#include <uf_mb.h>
#include <uf_lib.h>
#include <uf_cam.h>

#include "afxtempl.h"

#include <windows.h>

#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#	include <strstream>
#   include <iostream>
	using std::ostrstream;
	using std::endl;
	using std::ends;
	using std::cerr;
#else
#	include <strstream.h>
#   include <iostream.h>
#endif
#include "libtoolmat.h"


#define mStr  255

class TOOL_MATERIALS
{
 public :
	char FORMAT[10];
	char LIBREF[20]; //material_code         - Unique record identifier
	char MATNAM[50]; //material_name         - Material Name  (appears on the label)
	char MATDESC[133]; //material_description  - Material Description
	long int  util; // 

 TOOL_MATERIALS ()
 {
   Init();
 }

 virtual ~TOOL_MATERIALS () { ; }

 void Init() { FORMAT[0]='\0'; LIBREF[0]='\0'; MATNAM[0]='\0'; MATDESC[0]='\0'; util=0; }

 char * FormatChar(CString str)
 {
   char ls[255], *ptr;
   ls[0]='\0'; sprintf(ls,"%s",str ); //(LPCTSTR)
   ptr = (char *) malloc(strlen(ls)+5);
   strcpy(ptr,ls);strcat(ptr,"\0");
   return(ptr);
 }

 void FormatList(char * str)
 { sprintf(str,"%.50s  = %.80s",MATNAM, MATDESC );  }

 void FormatFile(char * str)
 { sprintf(str,"%.5s|%.20s|%.50s|%.133s\n", FORMAT , LIBREF , MATNAM , MATDESC );  }

 void FormatHelp(char * str)
 { sprintf(str,"%.5s|%.20s|%.50s|%.133s  :util(%d)\n", FORMAT, LIBREF, MATNAM, MATDESC , util);  }

} ;

 CArray < TOOL_MATERIALS, TOOL_MATERIALS& > myTM ;

 char tool_materials[255];
 int SaveFlag;

/* The following definition defines the number of callback entries */
/* in the callback structure:                                      */
/* UF_STYLER_callback_info_t TM_cbs */
#define TM_CB_COUNT ( 5 + 1 ) /* Add 1 for the terminator */

/*--------------------------------------------------------------------------
The following structure defines the callback entries used by the
styler file.  This structure MUST be passed into the user function,
UF_STYLER_create_dialog along with TM_CB_COUNT.
--------------------------------------------------------------------------*/
static UF_STYLER_callback_info_t TM_cbs[TM_CB_COUNT] =
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, TM_construct_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, TM_ok_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CANCEL_CB       , 0, TM_cancel_cb},
 {TM_LIST_TOOL_MATERIAL , UF_STYLER_ACTIVATE_CB     , 0, TM_list_tool_material_cb},
 {TM_BLO_ACT            , UF_STYLER_ACTIVATE_CB     , 1, TM_blo_act_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



/*--------------------------------------------------------------------------
UF_MB_styler_actions_t contains 4 fields.  These are defined as follows:

Field 1 : the name of your dialog that you wish to display.
Field 2 : any client data you wish to pass to your callbacks.
Field 3 : your callback structure.
Field 4 : flag to inform menubar of your dialog location.  This flag MUST
          match the resource set in your dialog!  Do NOT ASSUME that changing
          this field will update the location of your dialog.  Please use the
          UIStyler to indicate the position of your dialog.
--------------------------------------------------------------------------*/
static UF_MB_styler_actions_t actions[] = {
    { "libtoolmat.dlg",  NULL,   TM_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};

//----------------------------------------------------------------------------
//  Activation Methods
//----------------------------------------------------------------------------

//  Explicit Activation
//      This entry point is used to activate the application explicitly, as in
//      "File->Execute UG/Open->User Function..."
extern "C" DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
    /* Initialize the API environment */
    int i ;
    int response=0;
    char fail_message[133];
    int errorCode = UF_initialize();


    if ( 0 == errorCode )
    {
        /* TODO: Add your application code here */
     i=ToolMaterial_Init();
     if (i<0) {
        fail_message[0]='\0';
        sprintf(fail_message,"        \n    .");
        MessageBeep(0);
        MessageBox(GetFocus(),(LPCTSTR)fail_message," - ->.",MB_ICONSTOP|MB_OK);
     }

    if ( ( errorCode = UF_STYLER_create_dialog ( "libtoolmat.dlg",
           TM_cbs,      /* Callbacks from dialog */
           TM_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           &response ) ) != 0 )
    {
          /* Get the user function fail message based on the fail code.*/
          fail_message[0]='\0';
          UF_get_fail_message(errorCode, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message );
    }


        /* Terminate the API environment */
        errorCode = UF_terminate();
    }

    /* Print out any error messages */
    PrintErrorMessage( errorCode );
}

//----------------------------------------------------------------------------
//  Utilities
//----------------------------------------------------------------------------

/* PrintErrorMessage
**
**     Prints error messages to standard error and the Unigraphics status
**     line. */
static void PrintErrorMessage( int errorCode )
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        // Construct a buffer to hold the text.
        ostrstream error_message;

        // Initialize the buffer with the required text.
        error_message << endl
                      << "Error:" << endl
                      << message
                      << endl << endl << ends;

	    // Write the message to standard error
        cerr << error_message.str();
    }
}

/*--------------------------------------------------------------------------
This function specifies how a shared image is unloaded from memory
within Unigraphics. This function gives you the capability to unload an
internal UG/Open application or user  exit from Unigraphics.  You can
specify any one of the three constants as a return value to determine
the type of unload to perform:  immediately after user function
execution, via an unload selection dialog, or when Unigraphics terminates
terminates.  If you choose UF_UNLOAD_SEL_DIALOG, then you have the
option to unload your image by selecting  File->Utilities->Unload Shared
Image.

NOTE:  A program which associates UG/Open applications with the menubar
MUST NOT use this option since it will UNLOAD your UG/Open application image
--------
from the menubar.
--------------------------------------------------------------------------*/

extern int ufusr_ask_unload (void)
{
     /* unload immediately after application exits*/
     return ( UF_UNLOAD_IMMEDIATELY );

     /*via the unload selection dialog... */
     //return ( UF_UNLOAD_SEL_DIALOG );
     /*when UG terminates...              */
     /*return ( UF_UNLOAD_UG_TERMINATE ); */
}



/*--------------------------------------------------------------------------
You have the option of coding the cleanup routine to perform any housekeeping
chores that may need to be performed.  If you code the cleanup routine, it is
automatically called by Unigraphics.
--------------------------------------------------------------------------*/
extern void ufusr_cleanup (void)
{
    return;
}


/*-------------------------------------------------------------------------*/
/*---------------------- UIStyler Callback Functions ----------------------*/
/*-------------------------------------------------------------------------*/

/* -------------------------------------------------------------------------
 * Callback Name: TM_construct_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int TM_construct_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t data  ;
    int irc ;
    long int i , l;
    char str[255] ; // CString
    //char ls[255];
    TOOL_MATERIALS tm ;

     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     i=ToolMaterial_Load();
     if (i==0) {
       l= myTM.GetSize();
       if (l>0) {
	 data.item_id=TM_LIST_TOOL_MATERIAL;
         data.item_attr=UF_STYLER_LIST_INSERT;
         data.subitem_index=UF_STYLER_NO_SUB_INDEX;
         data.indicator=UF_STYLER_STRING_VALUE ; // UF_STYLER_STRING_PTR_VALUE ;
         for (i=0;i<l;i++) {
           tm = myTM.GetAt(i);
           str[0]='\0'; tm.FormatList(str);
           //MessageBox(GetFocus(),(LPCTSTR)str,"TM_construct_cb",MB_ICONSTOP|MB_OK);
           data.subitem_index=i;
	   data.value.string=str; //(char**)ls;
           irc=UF_STYLER_set_value(dialog_id,&data);
         }
         data.item_attr=UF_STYLER_VALUE;
         data.subitem_index=0;
         irc=UF_STYLER_set_value(dialog_id,&data);
         UF_STYLER_free_value (&data) ;
       }
     }

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);
    /* A return value of UF_UI_CB_EXIT_DIALOG will not be accepted    */
    /* for this callback type.  You must continue dialog construction.*/

}


/* -------------------------------------------------------------------------
 * Callback Name: TM_ok_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int TM_ok_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_EXIT_DIALOG);

}


/* -------------------------------------------------------------------------
 * Callback Name: TM_cancel_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int TM_cancel_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a cancel call */
    /* back rather than UF_UI_CB_CONTINUE_DIALOG.          */
    return ( UF_UI_CB_EXIT_DIALOG );

}


/* -------------------------------------------------------------------------
 * Callback Name: TM_list_tool_material_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int TM_list_tool_material_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: TM_blo_act_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int TM_blo_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t data  ;
    int irc ;
    int i , k , l;
    char str[255] ;
    TOOL_MATERIALS tm ;

     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     data.item_id=TM_BLO_ACT;
     data.item_attr=UF_STYLER_VALUE;
     irc=UF_STYLER_ask_value(dialog_id,&data);
     i=data.value.integer;

  switch (i) {
   case 0 : // 
	 data.item_id=TM_LIST_TOOL_MATERIAL;

         data.item_attr=UF_STYLER_VALUE;
         data.indicator=UF_STYLER_INTEGER_VALUE ;
         irc=UF_STYLER_ask_value(dialog_id,&data);
         k=data.value.integer ;
         irc=ToolMaterial_Edit_New(k);
         if (k>=0 && irc==UF_UI_OK) {

            data.item_attr=UF_STYLER_LIST_DELETE;
            data.subitem_index=UF_STYLER_NO_SUB_INDEX;
            irc=UF_STYLER_set_value(dialog_id,&data);

            data.item_attr=UF_STYLER_LIST_INSERT;
            data.indicator=UF_STYLER_STRING_VALUE ;
            for (i=0;i<myTM.GetSize();i++) {
              tm = myTM.GetAt(i);
              str[0]='\0'; tm.FormatList(str);
              data.subitem_index=i;
              data.value.string=str;
              irc=UF_STYLER_set_value(dialog_id,&data);
            }

            data.item_attr=UF_STYLER_VALUE;
            data.subitem_index=k;
            irc=UF_STYLER_set_value(dialog_id,&data);

         }
   break;
   case 1 : //  
	 data.item_id=TM_LIST_TOOL_MATERIAL;

         data.item_attr=UF_STYLER_VALUE;
         data.indicator=UF_STYLER_INTEGER_VALUE ;
         irc=UF_STYLER_ask_value(dialog_id,&data);
         k=data.value.integer;

         i=ToolMaterial_Delete(k);
         if (i<0) break ;

         l= myTM.GetSize();
         if (l<0) break ;

         data.item_attr=UF_STYLER_LIST_DELETE;
	 data.subitem_index=UF_STYLER_NO_SUB_INDEX;
	 irc=UF_STYLER_set_value(dialog_id,&data);

         for (i=0;i<l;i++) {
           tm = myTM.GetAt(i);
           str[0]='\0'; tm.FormatList(str);
           data.item_attr=UF_STYLER_LIST_INSERT;
           data.indicator=UF_STYLER_STRING_VALUE ; // UF_STYLER_STRING_PTR_VALUE ;
           data.subitem_index=i;
           data.value.string=str;
           irc=UF_STYLER_set_value(dialog_id,&data);
         }

         if (k<=1) k=0; else k--;
         data.item_attr=UF_STYLER_VALUE;
         data.subitem_index=k;
         irc=UF_STYLER_set_value(dialog_id,&data);
   break;
   case 2 : //  
         irc=ToolMaterial_Edit_New(-1);
         if (irc==UF_UI_OK) {

	    data.item_id=TM_LIST_TOOL_MATERIAL;

            data.item_attr=UF_STYLER_LIST_DELETE;
            data.subitem_index=UF_STYLER_NO_SUB_INDEX;
            irc=UF_STYLER_set_value(dialog_id,&data);

            data.item_attr=UF_STYLER_LIST_INSERT;
            data.indicator=UF_STYLER_STRING_VALUE ;
            for (i=0;i<myTM.GetSize();i++) {
              tm = myTM.GetAt(i);
              str[0]='\0'; tm.FormatList(str);
              data.subitem_index=i;
              data.value.string=str;
              irc=UF_STYLER_set_value(dialog_id,&data);
            }

            data.item_attr=UF_STYLER_VALUE;
            data.subitem_index=myTM.GetSize()-1;
            irc=UF_STYLER_set_value(dialog_id,&data);

         }

   break;
   case 3 : // 
         ToolMaterial_List_Help();
   break;
   case 4 : //  
	 data.item_id=TM_LIST_TOOL_MATERIAL;

	 data.item_attr=UF_STYLER_LIST_DELETE;
	 data.subitem_index=UF_STYLER_NO_SUB_INDEX;
	 irc=UF_STYLER_set_value(dialog_id,&data);

         i=ToolMaterial_Load();
         if (i<0) break ;

         l= myTM.GetSize();
         if (l<=0) break ;

         data.item_attr=UF_STYLER_LIST_INSERT;
         data.indicator=UF_STYLER_STRING_VALUE ;
         for (i=0;i<l;i++) {
           tm = myTM.ElementAt(i);
           str[0]='\0';tm.FormatList(str);
           data.subitem_index=i;
           data.value.string=str;
           irc=UF_STYLER_set_value(dialog_id,&data);
         }
         data.item_attr=UF_STYLER_VALUE;
         data.subitem_index=0;
         irc=UF_STYLER_set_value(dialog_id,&data);
   break;
   case 5 : //  
         ToolMaterial_Save();
   break;

   case 6 : break;
   default : uc1601(" ",TRUE);
  }

     UF_STYLER_free_value (&data) ;
     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}




// ToolMaterial.cpp: implementation of the ToolMaterial class.
//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////

/*
**********************************************************
**********************************************************
*/
int ToolMaterial_Init()
{
/*    UGS -  */
// {UGII_CAM_LIBRARY_TOOL_METRIC_DIR}tool_database.dat
// {UGII_CAM_LIBRARY_FEEDS_SPEEDS_DATA_DIR}\
//    cut_methods.dat
//    feeds_speeds.dat
//    part_materials.dat
//    tool_materials.dat

  char *ptr1;
  int fl ;
  FILE *rf;

  tool_materials[0]='\0';
  SaveFlag=0;

  UF_translate_variable("UGII_CAM_LIBRARY_FEEDS_SPEEDS_DATA_DIR", &ptr1);
  if (ptr1==NULL) {
     uc1601 (" UGII_CAM_LIBRARY_FEEDS_SPEEDS_DATA_DIR -  ", 1 );
     return(-1);
   }

/*          */
  tool_materials[0]='\0';
  strcpy(tool_materials,ptr1); strcat(tool_materials,"tool_materials.dat");

  fl=0;
  rf=fopen(tool_materials,"r");
  if (rf==NULL) { fl=1; } else { fclose(rf); }

  rf=fopen(tool_materials,"a");
  if (rf==NULL) { SaveFlag=-1; } else { fclose(rf); }

  if (fl!=0) {
   return(-2);
  }

 return(0);
}


/*
**********************************************************
**********************************************************
*/
int ToolMaterial_Load()
{
 int i , k , index;
 char s[mStr], *ptr1, stmp[mStr];
 FILE *rf;
 TOOL_MATERIALS tm;

 rf=fopen(tool_materials,"r");
 if (rf==NULL) {
   MessageBox(GetFocus(),(LPCTSTR)"   \n   . "," -  ",MB_ICONSTOP|MB_OK);
   return(-1);
  }

 ptr1 = (char *) malloc(mStr+10);

 //myTM.SetSize(50);
 try
 {
    myTM.RemoveAll();
 }
  catch( char * str )
  {
        cerr << "Exception raised: " << str << '\n';
  }

 index=0;

 i=1; s[0]='\0'; fgets(s,mStr,rf);
 while(!feof(rf))
 {
   ptr1=strchr(s,'#');
   if (ptr1==NULL) {
	 stmp[0]='\0'; sprintf(stmp,"%.5s",s);
	 ptr1 = strstr(stmp, "DATA");
	 if (ptr1!=NULL) {

           tm.Init();

           strcpy(tm.FORMAT,"DATA\0");
	   ptr1=strchr(s,'|');
	   if (ptr1==NULL) continue;
	   stmp[0]='\0'; strcpy(stmp,ptr1+1);
	   ptr1=strchr(stmp,'|');
	   if (ptr1==NULL) continue;
	   k=ptr1-stmp;
	   strncpy(tm.LIBREF,stmp,k); //strcat(tm.LIBREF,"\0");
	   tm.LIBREF[k]='\0';

	   stmp[0]='\0'; strcpy(stmp,ptr1+1);
	   ptr1=strchr(stmp,'|');
	   if (ptr1==NULL) continue;
	   k=ptr1-stmp;
	   strncpy(tm.MATNAM,stmp,k); //strcat(tm.MATNAM,"\0");
	   tm.MATNAM[k]='\0';

	   stmp[0]='\0'; strcpy(stmp,ptr1+1);
	   ptr1=strchr(stmp,'|');
	   if (ptr1!=NULL) continue;
	   ptr1=strchr(stmp,'\n');
	   if (ptr1!=NULL)
	   {
	     k=ptr1-stmp;
	     strncpy(tm.MATDESC,stmp,k);
	   } else {
	     strcpy(tm.MATDESC,stmp);
	   }
           //strcat(tm.MATDESC,"\0");
           tm.MATDESC[k]='\0';

           tm.util=index;

           myTM.Add( tm );
	   index++;
	 }
   }

   //printf("%s ",s);

   i++; s[0]='\0'; fgets(s,mStr,rf);
 }

 fclose(rf);

 return(0);
}


/*
**********************************************************
**********************************************************
*/
int ToolMaterial_Delete(int index)
{
 if (index<0 || index>=myTM.GetSize()) return (-1);

 try
 {
   myTM.RemoveAt(index);
 }
  catch( char * str )
  {
    cerr << "Exception raised: " << str << '\n';
  }

 return (0);
}


/*
**********************************************************
**********************************************************
*/
int ToolMaterial_Save()
{
 int index , l;
 char str[mStr] ;
 FILE *rf;
 TOOL_MATERIALS tm;

 if (SaveFlag==-1) {
   MessageBox(GetFocus(),(LPCTSTR)"   \n   . "," -  ",MB_ICONSTOP|MB_OK);
   return(-1);
  }

 l=myTM.GetSize();
 if (l<=0) {
   uc1601("   \n  ...",TRUE);
   return(-1);
  }

 index=MessageBox(GetFocus(),(LPCTSTR)" ,      ?\n       -   \n   ..."," ...",MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2);
 if (index==IDNO) return (0) ;

 rf=fopen(tool_materials,"w");
 if (rf==NULL) {
   MessageBox(GetFocus(),(LPCTSTR)"   \n   . "," -  ",MB_ICONSTOP|MB_OK);
   return(-2);
 }

 fputs("# TOOL_MATERIALS.DAT\n",rf);
 fputs("##########################################################################\n",rf);
 fputs("#\n",rf);
 fputs("#   PURPOSE:\n",rf);
 fputs("#\n",rf);
 fputs("#      This is the database file used for defining Tool Material.\n",rf);
 fputs("#\n",rf);
 fputs("##########################################################################\n",rf);
 fputs("##\n",rf);
 fputs("##  The following key words for Attribute ids are defined\n",rf);
 fputs("##\n",rf);
 fputs("##  LIBREF   material_code         - Unique record identifier\n",rf);
 fputs("##                                   (Library Reference)\n",rf);
 fputs("##  MATNAM   material_name         - Material Name  (appears on the label)\n",rf);
 fputs("##  MATDESC  material_description  - Material Description\n",rf);
 fputs("#########################################################################\n",rf);
 fputs("#----------------+-------------------------------+-------------\n",rf);
 fputs("FORMAT LIBRF MATNAM MATDESC\n",rf);
 fputs("#----------------+-------------------------------+-------------\n",rf);

 l=myTM.GetSize();
 for (index=0;index<l;index++)
 {
   tm = myTM.GetAt(index);
   str[0]='\0'; tm.FormatFile(str);
   fputs(str,rf);
 }

 fclose(rf);

 str[0]='\0'; sprintf(str," ...\n   %ld - .", l );
 MessageBox(GetFocus(),(LPCTSTR)str," ...",MB_ICONINFORMATION|MB_OK);

 return(0);
}



/*
**********************************************************
**********************************************************
*/
int ToolMaterial_List_Help()
{
  int index ;
  char mes[mStr] ;
  char *release;
  TOOL_MATERIALS tm;

  UF_UI_open_listing_window();

  UF_get_release (&release );
  mes[0]='\0'; sprintf(mes,"\n  Unigraphics - %s ",release); UF_UI_write_listing_window(mes);

  mes[0]='\0'; sprintf(mes,"\n   ."); UF_UI_write_listing_window(mes);

  mes[0]='\0'; sprintf(mes,"\n\t . (Win32 API, MFC, VC++6.0) "); UF_UI_write_listing_window(mes);
  UF_UI_write_listing_window("\n      :     .");
  UF_UI_write_listing_window("\n#============================================================");

  UF_UI_write_listing_window("\n    :");
  UF_UI_write_listing_window("\n  '' -   ");
  UF_UI_write_listing_window("\n  ' ' -   ");
  UF_UI_write_listing_window("\n  ' ' -   ,    ");
  UF_UI_write_listing_window("\n  '/' -       .");
  UF_UI_write_listing_window("\n  ' ' -     ");
  UF_UI_write_listing_window("\n  ' ' -     ");

  UF_UI_write_listing_window("\n\n#-----------------------------------------------------------");

UF_UI_write_listing_window("\n\n\t  Accessing the Tool Material Library [    ]");
UF_UI_write_listing_window("\n           Tool [].");
UF_UI_write_listing_window("\n        :");
UF_UI_write_listing_window("\n               .");
UF_UI_write_listing_window("\n       MB3      , ");
UF_UI_write_listing_window("\n                 ");
UF_UI_write_listing_window("\n        Insert [] -> Tool [].");
UF_UI_write_listing_window("\n       Insert Tool [ ]");
UF_UI_write_listing_window("\n      :");
UF_UI_write_listing_window("\n       1.   Material []    Search Result [ ]    .");
UF_UI_write_listing_window("\n       2.      Tool Material Library [  ].");
UF_UI_write_listing_window("\n             .");
UF_UI_write_listing_window("\n       3.      Cut Method Library [  ].");

UF_UI_write_listing_window("\n\n#-----------------------------------------------------------");

  UF_UI_write_listing_window("\n\n        'Tool Material'.");
  UF_UI_write_listing_window("\n      :");
  UF_UI_write_listing_window("\n\t  LIBREF   material_code         -   ");
  UF_UI_write_listing_window("\n\t  MATNAM   material_name         -    (    )");
  UF_UI_write_listing_window("\n\t  MATDESC  material_description  -  ");
  UF_UI_write_listing_window("\n ");

  UF_UI_write_listing_window("\n#-----------------------------------------------------------");
  UF_UI_write_listing_window("\n#   :");
  mes[0]='\0';
  sprintf(mes,"\n# Count=%ld\n# SaveFlag=%d\n# Name=%s ",myTM.GetSize(), SaveFlag , tool_materials);
  UF_UI_write_listing_window(mes);
  UF_UI_write_listing_window("\n#-----------------------------------------------------------");
  UF_UI_write_listing_window("\nFORMAT LIBRF MATNAM MATDESC\n");
  for (index=0;index<myTM.GetSize();index++)
  {
    tm = myTM.GetAt(index);
    mes[0]='\0';  tm.FormatHelp(mes);
    UF_UI_write_listing_window(mes);
  }

  UF_UI_write_listing_window("\n ");
  UF_UI_write_listing_window("\n#============================================================\n$$");

  //UF_UI_close_listing_window () ;

 return(0);

}


/*
**********************************************************
**********************************************************
*/
char * ToolMaterial_NewInd()
{
   int index ;
   long int i;
   char ls[25], *ptr ;
   TOOL_MATERIALS tm;

   /* Seed the random-number generator with current time so that
    * the numbers will be different every time we run. */
  srand( (unsigned)time( NULL ) );
  ls[0]='\0'; sprintf(ls,"TMC0_%04d",rand() );

  for (i=0,index=0;index<myTM.GetSize();index++)
  {
    tm = myTM.GetAt(index);
    if (0==strcmp( ls, tm.LIBREF)) {
    	if (i>1000) break;
    	ls[0]='\0'; sprintf(ls,"TMC0_%04d",rand() );
    	i++;
    	continue;
     }
  }

  ptr = (char *) malloc(strlen(ls)+5);
  strcpy(ptr,ls);strcat(ptr,"\0");
 return(ptr);
}



/************************************************************************************************/

int INDEX_REC ; // if INDEX_REC>=0   
                // if INDEX_REC=-1  

#include "libtoolmatedit.h"


/* The following definition defines the number of callback entries */
/* in the callback structure:                                      */
/* UF_STYLER_callback_info_t EC_cbs */
#define EC_CB_COUNT ( 6 + 1 ) /* Add 1 for the terminator */

/*--------------------------------------------------------------------------
The following structure defines the callback entries used by the
styler file.  This structure MUST be passed into the user function,
UF_STYLER_create_dialog along with EC_CB_COUNT.
--------------------------------------------------------------------------*/
static UF_STYLER_callback_info_t EC_cbs[EC_CB_COUNT] =
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, EC_cons_mat_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, EC_ok_mat_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CANCEL_CB       , 0, EC_cancel_mat_cb},
 {EC_WIDE_NUM           , UF_STYLER_ACTIVATE_CB     , 0, EC_number_cb},
 {EC_WIDE_MAT           , UF_STYLER_ACTIVATE_CB     , 0, EC_cancel_mat_cb},
 {EC_WIDE_DISCRIPTION   , UF_STYLER_ACTIVATE_CB     , 0, EC_description_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



int ToolMaterial_Edit_New(int index)
{
    char fail_message[133];
    int  response   = 0;
    int  error_code = 0;

    if ( ( UF_initialize() ) != 0 ) return (-1);

    INDEX_REC=index;

    if ( ( error_code = UF_STYLER_create_dialog ( "libtoolmatedit.dlg",
           EC_cbs,      /* Callbacks from dialog */
           EC_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           &response ) ) != 0 )
    {
          /* Get the user function fail message based on the fail code.*/
          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message );
          UF_terminate();
          return (-2);
    }

    UF_terminate();
    return (response);
}

/*-------------------------------------------------------------------------*/
/*---------------------- UIStyler Callback Functions ----------------------*/
/*-------------------------------------------------------------------------*/

/* -------------------------------------------------------------------------
 * Callback Name: EC_cons_mat_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int EC_cons_mat_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t data  ;
    int irc ;
    TOOL_MATERIALS tm;

     /* Make sure User Function is available. */
     if ( UF_initialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     data.item_attr=UF_STYLER_VALUE ;

     if (INDEX_REC>=0) {
       tm = myTM.GetAt(INDEX_REC);

       data.item_id=EC_WIDE_NUM ;
       data.value.string=tm.LIBREF;
       irc=UF_STYLER_set_value(dialog_id,&data);

       data.item_id=EC_WIDE_MAT ;
       data.value.string=tm.MATNAM;
       irc=UF_STYLER_set_value(dialog_id,&data);

       data.item_id=EC_WIDE_DISCRIPTION ;
       data.value.string=tm.MATDESC;
       irc=UF_STYLER_set_value(dialog_id,&data);

     } else {

       data.item_id=EC_WIDE_NUM ;
       data.value.string=ToolMaterial_NewInd();
       irc=UF_STYLER_set_value(dialog_id,&data);

       data.item_id=EC_WIDE_MAT ;
       data.value.string="BT20\0";
       irc=UF_STYLER_set_value(dialog_id,&data);

       data.item_id=EC_WIDE_DISCRIPTION ;
       data.value.string="Ti ()\0";
       irc=UF_STYLER_set_value(dialog_id,&data);

     }

    data.item_attr=UF_STYLER_FOCUS ;

    data.item_id=EC_WIDE_MAT ;
    irc=UF_STYLER_set_value(dialog_id,&data);

    UF_STYLER_free_value (&data) ;

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);
    /* A return value of UF_UI_CB_EXIT_DIALOG will not be accepted    */
    /* for this callback type.  You must continue dialog construction.*/

}


/* -------------------------------------------------------------------------
 * Callback Name: EC_ok_mat_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int EC_ok_mat_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t data  ;
    int irc ;
    TOOL_MATERIALS tm;

     /* Make sure User Function is available. */
     if ( UF_initialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     data.item_attr=UF_STYLER_VALUE ;

     if (INDEX_REC>=0) {

       tm = myTM.GetAt(INDEX_REC);

       data.item_id=EC_WIDE_NUM ;
       irc=UF_STYLER_ask_value(dialog_id,&data);
       strcpy(tm.LIBREF,data.value.string);
       strcat(tm.LIBREF,"\0");

       data.item_id=EC_WIDE_MAT ;
       irc=UF_STYLER_ask_value(dialog_id,&data);
       strcpy(tm.MATNAM,data.value.string);
       strcat(tm.MATNAM,"\0");

       data.item_id=EC_WIDE_DISCRIPTION ;
       irc=UF_STYLER_ask_value(dialog_id,&data);
       strcpy(tm.MATDESC,data.value.string);
       strcat(tm.MATDESC,"\0");

       myTM.SetAt(INDEX_REC, tm);

     } else {

       tm.Init();

       strcpy(tm.FORMAT,"DATA\0");

       data.item_id=EC_WIDE_NUM ;
       irc=UF_STYLER_ask_value(dialog_id,&data);
       strcpy(tm.LIBREF,data.value.string);
       strcat(tm.LIBREF,"\0");

       data.item_id=EC_WIDE_MAT ;
       irc=UF_STYLER_ask_value(dialog_id,&data);
       strcpy(tm.MATNAM,data.value.string);
       strcat(tm.MATNAM,"\0");

       data.item_id=EC_WIDE_DISCRIPTION ;
       irc=UF_STYLER_ask_value(dialog_id,&data);
       strcpy(tm.MATDESC,data.value.string);
       strcat(tm.MATDESC,"\0");

       tm.util=0;

       myTM.Add( tm );

      }

     UF_STYLER_free_value (&data) ;

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_EXIT_DIALOG);

}


/* -------------------------------------------------------------------------
 * Callback Name: EC_cancel_mat_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int EC_cancel_mat_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a cancel call */
    /* back rather than UF_UI_CB_CONTINUE_DIALOG.          */
    return ( UF_UI_CB_EXIT_DIALOG );

}


/* -------------------------------------------------------------------------
 * Callback Name: EC_number_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int EC_number_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: EC_description_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the UG/Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int EC_description_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}
